ServerEvents.recipes(event => {
    event.remove({ output: 'ae2:crafting_terminal' })
    event.shapeless(
        Item.of('ae2:crafting_terminal'),
        [
            'ae2:terminal',
            [
                'minecraft:crafting_table',
                'quark:crafter'
            ],
            [
                'botania:world_seed',
                'ae2:calculation_processor'
            ]
        ]
    )
    event.shaped(
        Item.of('ae2:mysterious_cube'),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: 'ae2:sky_stone_block',
            B: 'ae2:fluix_block',
            C: 'dmnr:mutandis'
        }
    )
    event.remove({ output: 'ae2:inscriber' })
    event.shaped(
        Item.of('ae2:inscriber'),
        [
            'ABC',
            'ADE',
            'ABC'
        ],
        {
            A: 'minecraft:iron_ingot',
            B: 'minecraft:sticky_piston',
            C: 'minecraft:copper_ingot',
            D: 'kubejs:machine_frame',
            E: 'immersiveengineering:circuit_board'
        }
    )
    event.shaped(
        Item.of('ae2:quartz_glass', 4),
        [
            'ABA',
            'BAB',
            'ABA'
        ],
        {
            A: '#forge:dusts/quartz',
            B: '#c:glass_blocks'
        }
    )
    event.shaped(
        Item.of('ae2:quartz_fiber', 3),
        [
            'BBB',
            'AAA',
            'BBB'
        ],
        {
            A: '#forge:dusts/quartz',
            B: '#c:glass_blocks'
        }
    )
    event.remove({ output: 'ae2:controller' })
    event.shaped(
        Item.of('ae2:controller'),
        [
            'ABA',
            'CDC',
            'AEA'
        ],
        {
            A: 'ae2:smooth_sky_stone_block',
            B: 'ae2:engineering_processor',
            C: 'ae2:fluix_block',
            D: 'kubejs:machine_frame',
            E: 'immersiveengineering:logic_circuit'
        }
    )
    event.remove({ output: 'ae2:charger' })
    event.shaped(
        Item.of('ae2:charger'),
        [
            'ABC',
            'AD ',
            'AEC'
        ],
        {
            A: 'minecraft:iron_ingot',
            B: 'immersiveengineering:charging_station',
            C: 'minecraft:copper_ingot',
            D: 'kubejs:machine_frame',
            E: 'immersiveengineering:circuit_board'
        }
    )
    event.remove({ output: 'ae2:vibration_chamber' })
    event.shaped(
        Item.of('ae2:vibration_chamber'),
        [
            'ABA',
            'CDC',
            'CEC'
        ],
        {
            A: 'minecraft:copper_ingot',
            B: 'ae2:fluix_crystal',
            C: 'minecraft:iron_ingot',
            D: 'minecraft:furnace',
            E: 'kubejs:machine_frame'
        }
    )
    event.remove({ output: 'ae2:energy_acceptor' })
    event.shaped(
        Item.of('ae2:energy_acceptor'),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: 'minecraft:copper_ingot',
            B: 'ae2:quartz_glass',
            C: 'ae2:vibration_chamber'
        }
    )
    event.remove({ output: 'ae2:crystal_resonance_generator' })
    event.shaped(
        Item.of('ae2:crystal_resonance_generator'),
        [
            'ABA',
            'ADA',
            'CEC'
        ],
        {
            A: 'minecraft:copper_ingot',
            B: 'ae2:fluix_block',
            C: 'minecraft:iron_ingot',
            D: 'ae2:charged_certus_quartz_crystal',
            E: 'ae2:energy_acceptor'
        }
    )
    event.remove({ output: 'ae2:chest' })
    event.shaped(
        Item.of('ae2:chest'),
        [
            'ABA',
            'CDC',
            'EFE'
        ],
        {
            A: '#c:glass_blocks',
            B: 'ae2:terminal',
            C: '#ae2:glass_cable',
            D: 'kubejs:machine_frame',
            E: 'minecraft:iron_ingot',
            F: 'minecraft:copper_ingot'
        }
    )
    event.remove({ output: 'ae2:drive' })
    event.shaped(
        Item.of('ae2:drive'),
        [
            'AEA',
            'CDC',
            'ABA'
        ],
        {
            A: 'minecraft:iron_ingot',
            B: 'immersiveengineering:logic_circuit',
            C: 'ae2:engineering_processor',
            D: 'kubejs:machine_frame',
            E: 'minecraft:chiseled_bookshelf'
        }
    )
    event.remove({ output: 'ae2:molecular_assembler' })
    event.shaped(
        Item.of('ae2:molecular_assembler'),
        [
            'ABA',
            'CDE',
            'AFA'
        ],
        {
            A: 'minecraft:iron_ingot',
            B: 'quark:crafter',
            C: 'ae2:annihilation_core',
            D: 'kubejs:machine_frame',
            E: 'ae2:formation_core',
            F: 'immersiveengineering:logic_circuit'
        }
    )
    event.remove({ output: 'ae2:pattern_provider' })
    event.shaped(
        Item.of('ae2:pattern_provider'),
        [
            'ABA',
            'CDE',
            'AFA'
        ],
        {
            A: 'minecraft:iron_ingot',
            B: 'create:stock_link',
            C: 'ae2:annihilation_core',
            D: 'kubejs:machine_frame',
            E: 'ae2:formation_core',
            F: 'immersiveengineering:logic_circuit'
        }
    )
    event.remove({ output: 'ae2:interface' })
    event.shaped(
        Item.of('ae2:interface'),
        [
            'ABA',
            'CDE',
            'AFA'
        ],
        {
            A: 'minecraft:iron_ingot',
            B: 'create:package_frogport',
            C: 'ae2:annihilation_core',
            D: 'kubejs:machine_frame',
            E: 'ae2:formation_core',
            F: 'immersiveengineering:logic_circuit'
        }
    )
    event.remove({ output: 'ae2:crafting_unit' })
    event.shaped(
        Item.of('ae2:crafting_unit'),
        [
            'ABA',
            'CDC',
            'AEA'
        ],
        {
            A: 'minecraft:iron_ingot',
            B: 'create:stock_ticker',
            C: 'ae2:calculation_processor',
            D: 'kubejs:machine_frame',
            E: 'immersiveengineering:logic_circuit'
        }
    )
    event.remove({ id: 'expatternprovider:epp' })
    event.shapeless(
        Item.of('expatternprovider:ex_pattern_provider'),
        [
            '#megacells:mega_pattern_provider',
            '2x ae2:capacity_card',
            'ae2:engineering_processor'
        ]
    )
    event.remove({ id: 'megacells:network/mega_pattern_provider' })
    event.shapeless(
        Item.of('megacells:mega_pattern_provider'),
        [
            '#ae2:pattern_provider',
            'megacells:accumulation_processor',
            'ae2:calculation_processor'
        ]
    )
    event.remove({ output: 'extendedae_plus:mirror_pattern_provider' })
    event.shaped(
        Item.of('extendedae_plus:mirror_pattern_provider'),
        [
            'AAA',
            'ABA',
            'AAA'
        ],
        {
            A: 'ae2:quartz_glass',
            B: '#ae2:pattern_provider'
        }
    )
    event.remove({ id: 'expatternprovider:epp_upgrade' })
    event.shapeless(
        Item.of('expatternprovider:pattern_provider_upgrade'),
        [
            '2x ae2:capacity_card',
            'ae2:engineering_processor',
            'megacells:accumulation_processor',
            'ae2:calculation_processor'
        ]
    )
    event.remove({ id: 'advanced_ae:largeappupgrade' })
    event.shapeless(
        Item.of('advanced_ae:adv_pattern_provider_capacity_upgrade'),
        [
            '#forge:ingots',
            '2x ae2:capacity_card',
            'ae2:engineering_processor',
            'megacells:accumulation_processor',
            'ae2:calculation_processor'
        ]
    )
    event.remove({ id: 'expatternprovider:ei' })
    event.shapeless(
        Item.of('expatternprovider:ex_interface'),
        [
            '#megacells:mega_pattern_provider',
            '2x ae2:capacity_card',
            'ae2:logic_processor'
        ]
    )
    event.remove({ id: 'megacells:network/mega_interface' })
    event.shapeless(
        Item.of('megacells:mega_interface'),
        [
            '#ae2:pattern_provider',
            'megacells:accumulation_processor',
            'ae2:calculation_processor'
        ]
    )
    event.remove({ id: 'advanced_ae:largeappupgrade' })
    event.shapeless(
        Item.of('advanced_ae:adv_pattern_provider_capacity_upgrade'),
        [
            '#forge:ingots',
            '2x ae2:capacity_card',
            'ae2:logic_processor',
            'megacells:accumulation_processor',
            'ae2:calculation_processor'
        ]
    )
    event.remove({ output: 'ae2:blank_pattern' })
    event.shaped(
        Item.of('ae2:blank_pattern', 2),
        [
            'ABA',
            'BCB',
            'DED'
        ],
        {
            A: 'ae2:quartz_glass',
            B: 'minecraft:glowstone_dust',
            C: 'ae2:charged_certus_quartz_crystal',
            D: 'minecraft:iron_ingot',
            E: 'thermal:beekeeper_fabric'
        }
    )
    event.shaped(
        Item.of('ae2:blank_pattern'),
        [
            'A'
        ],
        {
            A: [
                Item.of('ae2:crafting_pattern'),
                Item.of('ae2:processing_pattern'),
                Item.of('ae2:stonecutting_pattern'),
                Item.of('ae2:smithing_table_pattern')
            ]
        }
    )
    event.remove({ id: 'ae2:network/cables/glass_fluix' })
    event.shaped(
        Item.of('ae2:fluix_glass_cable', 6),
        [
            'ABA',
            'CCC',
            'ABA'
        ],
        {
            A: 'ae2:quartz_glass',
            B: 'ae2:fluix_crystal',
            C: 'ae2:quartz_fiber'
        }
    )
    event.remove({ output: 'ae2:condenser' })
    event.shaped(
        Item.of('ae2:condenser'),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: 'minecraft:iron_ingot',
            B: 'ae2:quartz_glass',
            C: Item.of('occultism:dimensional_matrix')
        }
    )
    event.remove({ output: 'expatternprovider:assembler_matrix_frame' })
    event.shaped(
        Item.of('expatternprovider:assembler_matrix_frame', 4),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: 'mekanismelements:clump_high_quality_concrete_blue',
            B: 'minecraft:iron_ingot',
            C: 'industrialforegoing:machine_frame_simple'
        }
    )
    event.remove({ output: 'expatternprovider:assembler_matrix_wall' })
    event.shaped(
        Item.of('expatternprovider:assembler_matrix_wall', 2),
        [
            'ABA',
            'CDC',
            'AEA'
        ],
        {
            A: '#ae2:smart_cable',
            B: 'ae2:logic_processor',
            C: '#ae2:all_quartz',
            D: 'expatternprovider:assembler_matrix_frame',
            E: 'ae2:calculation_processor'
        }
    )
    event.remove({ output: 'expatternprovider:assembler_matrix_glass' })
    event.shapeless(
        Item.of('expatternprovider:assembler_matrix_glass'),
        [
            'expatternprovider:assembler_matrix_wall',
            'ae2:quartz_glass'
        ]
    )
    event.remove({ output: 'expatternprovider:assembler_matrix_pattern' })
    event.shaped(
        Item.of('expatternprovider:assembler_matrix_pattern'),
        [
            'ABA',
            'CDC',
            'ABA'
        ],
        {
            A: 'ae2:blue_lumen_paint_ball',
            B: '#expatternprovider:extended_pattern_provider',
            C: 'ae2:engineering_processor',
            D: 'expatternprovider:assembler_matrix_wall'
        }
    )
    event.remove({ output: 'expatternprovider:assembler_matrix_crafter' })
    event.shaped(
        Item.of('expatternprovider:assembler_matrix_crafter'),
        [
            'ABA',
            'CDC',
            'ABA'
        ],
        {
            A: 'ae2:purple_lumen_paint_ball',
            B: 'expatternprovider:ex_molecular_assembler',
            C: 'ae2:engineering_processor',
            D: 'expatternprovider:assembler_matrix_wall'
        }
    )
    event.remove({ output: 'expatternprovider:assembler_matrix_speed' })
    event.shaped(
        Item.of('expatternprovider:assembler_matrix_speed'),
        [
            'ABA',
            'CDC',
            'ABA'
        ],
        {
            A: 'ae2:red_lumen_paint_ball',
            B: 'ae2:speed_card',
            C: [
                Item.of('extendedae_plus:entity_speed_card', '{"EAS:mult":2}'),
                'projecte:watch_of_flowing_time'
            ],
            D: 'expatternprovider:assembler_matrix_wall'
        }
    )
    event.remove({ output: 'advanced_ae:quantum_structure' })
    event.shaped(
        Item.of('advanced_ae:quantum_structure', 4),
        [
            'ABA',
            'BCB',
            'ABA'
        ],
        {
            A: 'ae2:sky_stone_block',
            B: 'ae2:quartz_vibrant_glass',
            C: 'industrialforegoing:machine_frame_simple'
        }
    )
    event.remove({ output: 'advanced_ae:quantum_unit' })
    event.shaped(
        Item.of('advanced_ae:quantum_unit'),
        [
            'ABA',
            'CDC',
            'AEA'
        ],
        {
            A: 'mekanismelements:clump_high_quality_concrete_purple',
            B: 'megacells:mega_crafting_unit',
            C: 'ae2:singularity',
            D: 'advanced_ae:quantum_structure',
            E: 'advanced_ae:quantum_processor'
        }
    )
    event.remove({ output: 'advanced_ae:quantum_storage_component' })
    event.shaped(
        Item.of('advanced_ae:quantum_storage_component'),
        [
            'ABA',
            'CDC',
            'ACA'
        ],
        {
            A: 'advanced_ae:quantum_processor',
            B: 'ae2:cell_component_256k',
            C: 'ae2:spatial_cell_component_2',
            D: 'ae2:quartz_vibrant_glass'
        }
    )
    event.remove({ output: 'advanced_ae:quantum_storage_128' })
    event.shapeless(
        Item.of('advanced_ae:quantum_storage_128'),
        [
            'advanced_ae:quantum_unit',
            'advanced_ae:quantum_storage_component'
        ]
    )
    event.remove({ output: 'advanced_ae:quantum_accelerator' })
    event.shaped(
        Item.of('advanced_ae:quantum_accelerator'),
        [
            'ABA',
            'CDC',
            'ACA'
        ],
        {
            A: 'advanced_ae:shattered_singularity',
            B: 'extendedae_plus:4x_crafting_accelerator',
            C: 'advanced_ae:quantum_processor',
            D: 'advanced_ae:quantum_unit'
        }
    )
    event.remove({ output: 'advanced_ae:quantum_accelerator' })
    event.shaped(
        Item.of('advanced_ae:quantum_accelerator'),
        [
            ' A ',
            'BCB',
            'BDB'
        ],
        {
            A: 'ae2:fluix_pearl',
            B: 'minecraft:iron_ingot',
            C: 'ae2:quartz_fiber',
            D: [
                'mekanism:teleportation_core',
                'kubejs:world_core'
            ]
        }
    )
    event.remove({ output: 'extendedae_plus:wireless_transceiver' })
    event.shaped(
        Item.of('extendedae_plus:wireless_transceiver'),
        [
            'AAA',
            'ABA',
            'AAA'
        ],
        {
            A: 'ae2:quantum_ring',
            B: 'expatternprovider:wireless_connect'
        }
    )
    event.remove({ output: 'expatternprovider:wireless_connect' })
    event.shaped(
        Item.of('expatternprovider:wireless_connect'),
        [
            'ABA',
            'CDC',
            'AEA'
        ],
        {
            A: 'ae2:sky_dust',
            B: '#ae2:smart_dense_cable',
            C: 'ae2:wireless_receiver',
            D: 'kubejs:machine_frame',
            E: 'ae2:engineering_processor'
        }
    )
    event.remove({ output: 'expatternprovider:wireless_hub' })
    event.shaped(
        Item.of('expatternprovider:wireless_hub'),
        [
            'ABA',
            'CDC',
            'AEA'
        ],
        {
            A: '#ae2:smart_cable',
            B: 'ae2:wireless_receiver',
            C: 'ae2:engineering_processor',
            D: 'expatternprovider:wireless_connect',
            E: 'ae2:quantum_link'
        }
    )
    event.remove({ output: 'advanced_ae:auto_feeding_card' })
    event.shaped(
        Item.of('advanced_ae:auto_feeding_card'),
        [
            ' A ',
            'BCD',
            ' E '
        ],
        {
            A: 'ae2:wireless_access_point',
            B: 'minecraft:golden_carrot',
            C: 'advanced_ae:quantum_upgrade_base',
            D: 'minecraft:enchanted_golden_apple',
            E: 'minecraft:totem_of_undying'
        }
    )
    event.remove({ output: 'ae2:spatial_storage_cell_16' })
    event.shapeless(
        Item.of('ae2:spatial_storage_cell_16'),
        [
            'ae2:spatial_cell_component_16',
            'kubejs:spatial_storage_cell_housing'
        ]
    )
    event.remove({ output: 'ae2:spatial_storage_cell_128' })
    event.shapeless(
        Item.of('ae2:spatial_storage_cell_128'),
        [
            'ae2:spatial_cell_component_128',
            'kubejs:spatial_storage_cell_housing'
        ]
    )
    event.remove({ output: 'ae2:spatial_storage_cell_2' })
    event.shapeless(
        Item.of('ae2:spatial_storage_cell_2'),
        [
            'ae2:spatial_cell_component_2',
            'kubejs:spatial_storage_cell_housing'
        ]
    )
})